| TagLib 1.13 |  |

Public Member Functions | Static Public Member Functions | List of all members
TagLib::Ogg::FLAC::File Class Reference

An implementation of TagLib::File with Ogg/FLAC specific methods. More...

`#include <oggflacfile.h>`

Inheritance diagram for TagLib::Ogg::FLAC::File:
[legend]
Collaboration diagram for TagLib::Ogg::FLAC::File:
[legend]

## Public Member Functions
| File (FileName file, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle propertiesStyle=Properties::Average)
virtual | ~File ()
virtual XiphComment * | tag () const
virtual Properties * | audioProperties () const
PropertyMap | properties () const
PropertyMap | setProperties (const PropertyMap &)
virtual bool | save ()
long | streamLength ()
bool | hasXiphComment () const
Public Member Functions inherited from TagLib::Ogg::File
virtual | ~File ()
ByteVector | packet (unsigned int i)
void | setPacket (unsigned int i, const ByteVector &p)
const PageHeader * | firstPageHeader ()
const PageHeader * | lastPageHeader ()
virtual bool | save ()
Public Member Functions inherited from TagLib::File
virtual | ~File ()
FileName | name () const
virtual Tag * | tag () const =0
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &properties)
PropertyMap | setProperties (const PropertyMap &properties)
virtual AudioProperties * | audioProperties () const =0
virtual bool | save ()=0
ByteVector | readBlock (unsigned long length)
void | writeBlock (const ByteVector &data)
long | find (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
long | rfind (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, unsigned long start=0, unsigned long replace=0)
void | removeBlock (unsigned long start=0, unsigned long length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (long offset, Position p=Beginning)
void | clear ()
long | tell () const
long | length ()

## Static Public Member Functions
static bool | isSupported (IOStream *stream)
Static Public Member Functions inherited from TagLib::File
static TAGLIB_DEPRECATED bool | isReadable (const char *file)
static TAGLIB_DEPRECATED bool | isWritable (const char *name)

## Additional Inherited Members
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }
Protected Member Functions inherited from TagLib::Ogg::File
| File (FileName file)
| File (IOStream *stream)
Protected Member Functions inherited from TagLib::File
| File (FileName file)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (long length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with Ogg/FLAC specific methods.

This implements and provides an interface for Ogg/FLAC files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to Ogg FLAC files.

## Constructor & Destructor Documentation

## ◆ File() [1/2]

TagLib::Ogg::FLAC::File::File | ( | FileName | file,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | propertiesStyle = `Properties::Average`
| ) |  |

Constructs an Ogg/FLAC file from file. If readProperties is true the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

## ◆ File() [2/2]

TagLib::Ogg::FLAC::File::File | ( | IOStream * | stream,
|  | bool | readProperties = `true`,
|  | Properties::ReadStyle | propertiesStyle = `Properties::Average`
| ) |  |

Constructs an Ogg/FLAC file from stream. If readProperties is true the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.
  In the current implementation, propertiesStyle is ignored.

## ◆ ~File()

virtual TagLib::Ogg::FLAC::File::~File | ( |  | ) |
| virtual

Destroys this instance of the File.

Reimplemented from TagLib::Ogg::File.

## Member Function Documentation

## ◆ audioProperties()

virtual Properties * TagLib::Ogg::FLAC::File::audioProperties | ( |  | ) | const
| virtual

Returns the FLAC::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

## ◆ hasXiphComment()

bool TagLib::Ogg::FLAC::File::hasXiphComment | ( |  | ) | const

Returns whether or not the file on disk actually has a XiphComment.

See also
  tag()

## ◆ isSupported()

static bool TagLib::Ogg::FLAC::File::isSupported | ( | IOStream * | stream | ) |
| static

Check if the given stream can be opened as an Ogg FLAC file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

## ◆ properties()

PropertyMap TagLib::Ogg::FLAC::File::properties | ( |  | ) | const

Implements the unified property interface – export function. This forwards directly to XiphComment::properties().

## ◆ save()

virtual bool TagLib::Ogg::FLAC::File::save | ( |  | ) |
| virtual

Save the file. This will primarily save and update the XiphComment. Returns true if the save is successful.

Reimplemented from TagLib::Ogg::File.

## ◆ setProperties()

PropertyMap TagLib::Ogg::FLAC::File::setProperties | ( | const PropertyMap & |  | ) |

Implements the unified tag dictionary interface – import function. Like properties(), this is a forwarder to the file's XiphComment.

## ◆ streamLength()

long TagLib::Ogg::FLAC::File::streamLength | ( |  | ) |

Returns the length of the audio-stream, used by FLAC::Properties for calculating the bitrate.

## ◆ tag()

virtual XiphComment * TagLib::Ogg::FLAC::File::tag | ( |  | ) | const
| virtual

Returns the Tag for this file. This will always be a XiphComment.

Note
  This always returns a valid pointer regardless of whether or not the file on disk has a XiphComment. Use hasXiphComment() to check if the file on disk actually has a XiphComment.
  The Tag is still owned by the FLAC::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasXiphComment()

Implements TagLib::File.

The documentation for this class was generated from the following file:

- oggflacfile.h